<?php
  function ipCIDRCheck ($IP, $CIDR) {
    list ($net, $mask) = split ("/", $CIDR);
    
    $ip_net = ip2long ($net);
    $ip_mask = ~((1 << (32 - $mask)) - 1);

    $ip_ip = ip2long ($IP);

    $ip_ip_net = $ip_ip & $ip_mask;

    return ($ip_ip_net == $ip_net);
  }

function ucebna($ip) {
$ucebny = Array();
$ucebny['10.20.0.0/16'] = "FAPPZ - nelze urcit konkretni ucebnu";
$ucebny['10.40.0.192/27'] = "FLD - L016";
$ucebny['10.40.8.0/26'] = "FLD - L023";
$ucebny['10.40.8.0/27'] = "FLD - L024";
$ucebny['10.40.8.96/27'] = "FLD - L322";
$ucebny['10.10.1.192/27'] = "PEF - C11";
$ucebny['10.10.1.224/27'] = "PEF - C11";
$ucebny['10.10.0.96/27'] = "PEF - C13";
$ucebny['10.10.1.0/27'] = "PEF - C21";
$ucebny['10.10.1.32/27'] = "PEF - C22";
$ucebny['10.10.1.64/27'] = "PEF - C23";
$ucebny['10.10.1.96/27'] = "PEF - C24";
$ucebny['10.10.2.32/27'] = "PEF - E223";
$ucebny['10.10.3.0/27'] = "PEF - E239";
$ucebny['10.10.2.192/27'] = "PEF - E309";
$ucebny['10.10.2.224/27'] = "PEF - E309";
$ucebny['10.10.2.96/27'] = "PEF - E323";
$ucebny['10.10.0.192/27'] = "PEF - E333";
$ucebny['10.10.0.224/27'] = "PEF - E333";
$ucebny['10.10.2.144/27'] = "PEF - E341";
$ucebny['10.10.2.176/28'] = "PEF - vestibul";
$ucebny['10.30.1.160/27'] = "TF - M017/II";
$ucebny['10.30.1.128/26'] = "TF - M121/III";
$ucebny['10.30.1.128/26'] = "TF - M215AB/III";
$ucebny['10.30.1.0/28'] = "TF - M217/I";
$ucebny['10.30.0.13'] = "TF - M217/I";
$ucebny['10.31.2.110'] = "TF - M217/I";
$ucebny['10.30.1.32/27'] = "TF - M219/I";
$ucebny['10.30.1.192/27'] = "TF - M219/I";
$ucebny['10.31.2.0/25'] = "TF - M219/I";
$ucebny['10.30.1.64/27'] = "TF - M220/I";
$ucebny['10.30.1.224/27'] = "TF - M220/II";
$ucebny['10.30.0.112/28'] = "TF - M39/IV";
$ucebny['10.30.0.128/27'] = "TF - M39/IV";
$ucebny['10.30.1.96/27'] = "TF - Sklenik";
$ucebny['10.30.1.95'] = "TF - Sklenik";
$ucebny['10.30.1.128/28'] = "TF - Lab. fyziky";
$ucebny['10.31.4.69'] = "TF - Lab. fyziky";
$ucebny['10.11.128.160/27'] = "Rektorat - S16";
$ucebny['10.11.128.192/27'] = "Rektorat - S16";
$ucebny['10.11.128.192/27'] = "Rektorat - S19";
$ucebny['10.11.128.96/27'] = "Rektorat - IP01";
$ucebny['10.11.128.128/27'] = "Rektorat - IP02";
$ucebny['10.11.129.96/27'] = "Kolej - JIH";
$ucebny['10.11.129.128/27'] = "Kolej - JIH";
$ucebny['10.11.129.192/27'] = "Kolej - F";
$ucebny['10.11.129.224/27'] = "Kolej - F";
$ucebny['10.110.0.0/16'] = "CZU - Wifi";

  foreach ($ucebny as $key => $value) {
    if (ipCIDRCheck ($ip, $key)) return "<span title=\"$ip\">$value</span>";
  }
  if (ipCIDRCheck ($ip, "10.0.0.0/8")) return "<span title=\"$ip\">CZU - mimo zname ucebny</span>";
  return "<span title=\"$ip\">mimo CZU (<a href=\"javascript:\" onclick=\"this.innerHTML = '".gethostbyaddr($ip)."'\">detail</a>)</span>";
}

header("Content-Type: text/html; charset=utf-8");
require_once('../../config.php');
require_once('../../lib/weblib.php');
$outtxt = "Moodle Inspector - kontrola podezřelých aktivit studentů během testu";
print_header("Moodle Inspector by SPEV OIKT CZU",$outtxt);
print_heading($outtxt);
echo '<center><font color=red><strong>z předchozích dnů (včerejška a starší)</strong></font></center><br>';
//echo '<center><a href="https://moodle.czu.cz">...zpět na hlavní stránku...</a></center><br>';
?>
<body onload="setTimeout('document.getElementById(\'moment\').style.display = \'none\'',200);">
<?php
/*
<html>
<head>
<title>Moodle Inspector by SPEV OIKT CZU</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body onload="setTimeout('document.getElementById(\'moment\').style.display = \'none\'',200);">
<h1>Moodle Inspector <span style="color: red">BETA</span></h1>
<div>by <a href="mailto:lohr@oikt.czu.cz">SPEV OIKT CZU</a>, 2010</div>
<pre>

 */
?>
<?php
include "../../config.php";
if ($USER->id == 0) {
  die("Nejste přihlášen/a. Přihlaste se do Moodle a pak se na tuto stránku vraťte.");
}

echo "<strong>Výběr kurzu a testu</strong>";
print_box_start();

// print_r($GLOBALS);

$context = get_context_instance(CONTEXT_SYSTEM);
if (has_capability("moodle/legacy:admin", $context, $USER->id, false)) {
    $isadmin=true;
    echo "admin";
} else $isadmin=false;

$pole = Array();

$pole = $USER->lastcourseaccess;
arsort($pole);
$txt = join(",",array_keys($pole));

if ($isadmin) {
  $result = mysql_query("SELECT id, shortname, fullname FROM {$CFG->prefix}course ORDER BY fullname, shortname DESC");
} else {
  $result = mysql_query("SELECT id, shortname, fullname FROM {$CFG->prefix}course WHERE id IN ($txt) ORDER BY shortname DESC, fullname");
}

$op = Array();
$opole = Array();
while ($row = mysql_fetch_array($result)) {
  $op[$row[0]] = $row[1].":".$row[2];
  $opole[$row[0]] = $row[0];
}
mysql_free_result($result);

$result = mysql_query("SELECT sortorder FROM {$CFG->prefix}role WHERE shortname = 'teacher'");
$row = mysql_fetch_array($result);
mysql_free_result($result);
$max = $row[0];

$max = 6000;
$prava = Array();
$result = mysql_query("SELECT id FROM {$CFG->prefix}role WHERE sortorder <= $max");
while ($row = mysql_fetch_array($result)) {
  $prava[] = $row[0];
}
mysql_free_result($result);
$prava_txt = join(",",$prava);

// ----------------- mame id prav tech, kteri mohou vystupy prohlizet

$pristup = Array();
$result = mysql_query("SELECT c.instanceid FROM {$CFG->prefix}role_assignments ra JOIN mdl_kit_context c ON ra.contextid = c.id WHERE ra.userid = {$USER->id} AND c.contextlevel = 50 AND ra.roleid IN ($prava_txt) ");
while ($row = mysql_fetch_array($result)) {
  $pristup[] = $row[0];
//  echo "{$row[0]}<br>";
}

// ----------------- sekce vyhledavani kurzu, kde je clovek gaelpem

$cesty = Array();
$query = "SELECT c.path FROM {$CFG->prefix}role_assignments ra JOIN {$CFG->prefix}context c ON ra.contextid = c.id WHERE ra.userid = {$USER->id} AND c.contextlevel = 40 AND ra.roleid IN ($prava_txt)";
$result = mysql_query($query);
while ($row = mysql_fetch_array($result)) {
  $cesty[] = $row[0];
}

foreach ($cesty as $key => $value) {
  $query = "SELECT c.instanceid FROM {$CFG->prefix}context c WHERE path LIKE '{$value}/%' AND c.contextlevel = 50";
  $result = mysql_query($query);
  while ($row = mysql_fetch_array($result)) {
    $pristup[] = $row[0];
  }
}
// ----------------- konec gaelpa


if (!$isadmin) {
foreach($opole as $key => $value) {
  if (!in_array($key,$pristup)) {
    unset($opole[$key]);
//    echo $context[$key];
//    print_r(get_user_roles($context[$key],$USER->id));
  }
}
}

$kurz = isset($_REQUEST["kurz"]) ? (int)$_REQUEST["kurz"] : 0;

echo "<form action=\"./\" method=\"get\">";
echo "<i>Jako vyučující si můžete vybrat z těchto kurzů:</i><br />";
echo "<select name=\"kurz\" onchange=\"this.form.submit()\">";
echo "<option value=\"\">vyberte kurz</option>";
foreach($opole as $key => $value) {
  echo "<option value=\"$key\"".($kurz == $key ? " selected=\"selected\"" : "").">{$op[$key]}</option>";
}
echo "</select>";
echo "<input type=\"submit\" value=\"Vybrat\" /><br />";

if ($kurz == 0 || (!in_array($kurz,$pristup) && !$isadmin)) {
  echo "<i>Zvolte kurz pro zobrazení výběru testu.</i>";
} else {
  $quiz = isset($_REQUEST["quiz"]) ? (int)$_REQUEST["quiz"] : 0;
  $result = mysql_query("SELECT id, name FROM {$CFG->prefix}quiz WHERE course = $kurz");
  echo "<select name=\"quiz\" onchange=\"this.form.submit();\">";
  echo "<option value=\"\">vyberte test</option>";
  while ($row = mysql_fetch_array($result)) {
    echo "<option value=\"{$row[0]}\"".($quiz == $row[0] ? " selected=\"selected\"" : "").">{$row[1]}</option>";
  }
  echo "</select>";
  echo "<input type=\"submit\" value=\"Vybrat\" />";

print_box_end();

/*
echo "<strong>Podezřelé akce z dneška</strong>";
print_box_start();


// Dnesni akce - z log_daily
  if ($quiz > 0) {
    $result = mysql_query("SELECT l.userid, l.module, l.action, l.ip, l.time,
            u.firstname, u.lastname, u.email, u.username, l.url, qa.timestart,
            qa.timefinish FROM mdl_kit_quiz_attempts qa JOIN mdl_kit_log_daily l
            ON l.userid = qa.userid JOIN mdl_kit_quiz q ON qa.quiz = q.id
            JOIN mdl_kit_user u ON u.id = l.userid
            WHERE l.time > qa.timestart AND l.time < qa.timefinish AND q.id = $quiz
            AND l.module <> 'quiz' AND l.module <> 'course' 
            ORDER BY qa.timestart DESC, u.lastname, u.firstname, l.time");
    //echo "<span id=\"moment\" style=\"color: red;\">Probiha nacitani...</span><br />";
    echo "<i>Podezřelé akce v průběhu testu:</i><br />";
    echo "<table border=\"1\" cellspacing=\"0\" cellpadding=\"2\"><tr><th>Jméno</th><th>E-mail</th><th>Akce</th><th>Učebna</th><th>Test od</th><th>do</th><th>Čas akce</th></tr>\n";
    $i = 0;
    while ($row = mysql_fetch_array($result)) {
      if (isset($urls[$row["module"]])) {
        $url = $urls[$row["module"]];
      } else {
        $url = "mod/{$row["module"]}";
      }
      echo "<tr><td>".$row["lastname"]." ".$row["firstname"]."</td>".
      "<td><a href=\"mailto:".$row["email"]."\">".$row["username"]."</a></td>".
      "<td><a href=\"/".$url."/".$row["url"]."\">".$row["module"]." - ".$row["action"]."</a></td>".
      "<td>".ucebna($row["ip"])."</td>".
      "<td>...".date("d.m.Y H:i:s",$row["timestart"])."</td><td>...".date("H:i:s",$row["timefinish"])."</td>".
      "<td>...".date("d.m.Y H:i:s",$row["time"])."</td>".
      "</tr>";
      $i++;
    }
    echo "</table>\n";
    echo "<i>Celkem $i podezřelých akcí v průběhu testu.</i>\n\n";
  }
  print_box_end();
*/

  $urls["user"] = "user";
  
  if ($isadmin) {
    $urls["blog"] = "blog-inspect";
  } else {
    $urls["blog"] = "blog";
  }

  $urls["message"] = "message-inspect";
  $urls["notes"] = "notes";
  echo "<strong>Podezřelé akce z předchozích dnů</strong>";
  print_box_start();
  // Starsi akce - z log
  if ($quiz > 0) {
    $result = mysql_query("SELECT l.userid, l.module, l.action, l.ip, l.time,
            u.firstname, u.lastname, u.email, u.username, l.url, qa.timestart,
            qa.timefinish FROM {$CFG->prefix}quiz_attempts_back qa JOIN {$CFG->prefix}log l
            ON l.userid = qa.userid JOIN {$CFG->prefix}quiz q ON qa.quiz = q.id
            JOIN {$CFG->prefix}user_back u ON u.id = l.userid
            WHERE l.time > qa.timestart AND l.time < qa.timefinish AND q.id = $quiz
            AND l.module <> 'quiz' AND l.module <> 'course'
            ORDER BY qa.timestart DESC, u.lastname, u.firstname, l.time");
    echo "<span id=\"moment\" style=\"color: red;\">Probiha nacitani...</span><br />";
    echo "<i>Podezřelé akce v průběhu testu:</i><br />";
    echo "<table border=\"1\" cellspacing=\"0\" cellpadding=\"2\"><tr><th>Jméno</th><th>E-mail</th><th>Akce</th><th>Učebna</th><th>Test od</th><th>do</th><th>Čas akce</th></tr>\n";
    $i = 0;
    while ($row = mysql_fetch_array($result)) {
      if (isset($urls[$row["module"]])) {
        $url = $urls[$row["module"]];
      } else {
        $url = "mod/{$row["module"]}";
      }
      
      if (($row["module"]=="message")&&($isadmin) || ($row["module"]!="message")) {
        echo "<tr><td>".$row["lastname"]." ".$row["firstname"]."</td>".
        "<td><a href=\"mailto:".$row["email"]."\">".$row["username"]."</a></td>".
        "<td><a href=\"/".$url."/".$row["url"]."\">".$row["module"]." - ".$row["action"]."</a></td>".
        "<td>".ucebna($row["ip"])."</td>".
        "<td>".date("d.m.Y H:i:s",$row["timestart"])."</td><td>...".date("d.m.Y H:i:s",$row["timefinish"])."</td>".
        "<td>...".date("d.m.Y H:i:s",$row["time"])."</td>".
        "</tr>";
      } else {
        echo "<tr><td>".$row["lastname"]." ".$row["firstname"]."</td>".
        "<td><a href=\"mailto:".$row["email"]."\">".$row["username"]."</a></td>".
        "<td>".$row["module"]." - ".$row["action"]."</td>".
        "<td>".ucebna($row["ip"])."</td>".
        "<td>".date("d.m.Y H:i:s",$row["timestart"])."</td><td>...".date("d.m.Y H:i:s",$row["timefinish"])."</td>".
        "<td>...".date("d.m.Y H:i:s",$row["time"])."</td>".
        "</tr>";
      }

      $i++;
    }
    echo "</table>\n";
    echo "<i>Celkem $i podezřelých akcí v průběhu testu.</i>";
  }
  print_box_end();

}
//echo "</form></body></html>";
echo "</form>";

  echo '<strong>Podezřelé akce z dneška</strong>';
  echo '<a href="https://moodle.czu.cz/oikt-inspect/index.php?kurz='.$kurz.'&quiz='.$quiz.'"> ... spustit zde ...</a><br><br>';
  echo '<strong>Návrat do kurzu</strong>';
  echo '<a href="https://moodle.czu.cz/course/view.php?id='.$kurz.'"> ... zde ...</a><br>';


echo '<center>(c)2010 by <a href="mailto:lohr@oikt.czu.cz">SPEV OIKT CZU</a></center>';
print_footer('empty');

